MODULE CALCULATE_EXP_ABS_MAX_ORDERS_MODULE
    USE EXP_ABS_EXPANSION_COEFFICIENTS_MODULE
    USE CALCULATE_POLYNOMIAL_MODULE
    IMPLICIT NONE
    PRIVATE
    INTEGER, PARAMETER ::DP = SELECTED_REAL_KIND(15)
    INTEGER, PARAMETER ::NP_MAX_OLD= 128
    
    PUBLIC:: CALCULATE_ANN_NMAX
    PUBLIC:: CALCULATE_BNN_NMAX
    PUBLIC:: CALCULATE_CNN_NMAX
    PUBLIC:: NP_MAX_OLD, GET_NM_OLD
CONTAINS
    FUNCTION GET_NM_OLD(Np) RESULT(RES)
        INTEGER,INTENT(IN)::Np
        INTEGER::RES
        SELECT CASE (Np)
            CASE(0:8)
                RES=8
            CASE(9:32)
                RES=32
            CASE(33:128)
                RES=128
        END SELECT
    ENDFUNCTION
    FUNCTION CALCULATE_ANN_NMAX(x,Np) RESULT(RES)
        COMPLEX(DP),INTENT(IN)::x
        INTEGER,INTENT(IN)::Np
        COMPLEX(DP)::RES(0:1)
        SELECT CASE (Np)
            CASE(0:8)
                RES=CALC_MAX_MATCH_ORDER_A_8(x)
            CASE(9:32)
                RES=CALC_MAX_MATCH_ORDER_A_32(x)
            CASE(33:128)
                RES=CALC_MAX_MATCH_ORDER_A_128(x)
        END SELECT
    ENDFUNCTION
    FUNCTION CALCULATE_BNN_NMAX(x,Np) RESULT(RES)
        COMPLEX(DP),INTENT(IN)::x
        INTEGER,INTENT(IN)::Np
        COMPLEX(DP)::RES(0:1)
        SELECT CASE (Np)
        CASE(0:8)
            RES=CALC_MAX_MATCH_ORDER_B_8(x)
        CASE(9:32)
            RES=CALC_MAX_MATCH_ORDER_B_32(x)
        CASE(33:128)
            RES=CALC_MAX_MATCH_ORDER_B_128(x)
        END SELECT
    ENDFUNCTION
    FUNCTION CALCULATE_CNN_NMAX(x,Np) RESULT(RES)
        COMPLEX(DP),INTENT(IN)::x
        INTEGER,INTENT(IN)::Np
        COMPLEX(DP)::RES(0:1)
        SELECT CASE (Np)
        CASE(0:8)
            RES=CALC_MAX_MATCH_ORDER_C_8(x)
        CASE(9:32)
            RES=CALC_MAX_MATCH_ORDER_C_32(x)
        CASE(33:128)
            RES=CALC_MAX_MATCH_ORDER_C_128(x)
        END SELECT
    ENDFUNCTION
#define _FUNC CALC_MAX_MATCH_ORDER_A_8
#define _THRESHOLD0 THRESHOLD_0_A_8
#define _POINT0 BASE_SITE_0_A_8
#define _ARR0_0 MAX_MATCH_ORDER_COEFFS_0_A_8
#define _ARR0_1 MAX_MATCH_ORDER_COEFFS_0_A_9
#define _THRESHOLD1 THRESHOLD_1_A_8
#define _POINT1 BASE_SITE_1_A_8
#define _ARR1_0 MAX_MATCH_ORDER_COEFFS_1_A_8
#define _ARR1_1 MAX_MATCH_ORDER_COEFFS_1_A_9
#define _THRESHOLD2 THRESHOLD_2_A_8
#define _POINT2 BASE_SITE_2_A_8
#define _ARR2_0 MAX_MATCH_ORDER_COEFFS_2_A_8
#define _ARR2_1 MAX_MATCH_ORDER_COEFFS_2_A_9
#define _THRESHOLD3 THRESHOLD_3_A_8
#define _POINT3 BASE_SITE_3_A_8
#define _ARR3_0 MAX_MATCH_ORDER_COEFFS_3_A_8
#define _ARR3_1 MAX_MATCH_ORDER_COEFFS_3_A_9
#include "calc_match_max_order_template.F90"
#undef _THRESHOLD0
#undef _POINT0
#undef _ARR0_0
#undef _ARR0_1
#undef _THRESHOLD1
#undef _POINT1
#undef _ARR1_0
#undef _ARR1_1
#undef _THRESHOLD2
#undef _POINT2
#undef _ARR2_0
#undef _ARR2_1
#undef _THRESHOLD3
#undef _POINT3
#undef _ARR3_0
#undef _ARR3_1
#undef _FUNC

#define _FUNC CALC_MAX_MATCH_ORDER_A_32
#define _THRESHOLD0 THRESHOLD_0_A_32
#define _POINT0 BASE_SITE_0_A_32
#define _ARR0_0 MAX_MATCH_ORDER_COEFFS_0_A_32
#define _ARR0_1 MAX_MATCH_ORDER_COEFFS_0_A_33
#define _THRESHOLD1 THRESHOLD_1_A_32
#define _POINT1 BASE_SITE_1_A_32
#define _ARR1_0 MAX_MATCH_ORDER_COEFFS_1_A_32
#define _ARR1_1 MAX_MATCH_ORDER_COEFFS_1_A_33
#define _THRESHOLD2 THRESHOLD_2_A_32
#define _POINT2 BASE_SITE_2_A_32
#define _ARR2_0 MAX_MATCH_ORDER_COEFFS_2_A_32
#define _ARR2_1 MAX_MATCH_ORDER_COEFFS_2_A_33
#define _THRESHOLD3 THRESHOLD_3_A_32
#define _POINT3 BASE_SITE_3_A_32
#define _ARR3_0 MAX_MATCH_ORDER_COEFFS_3_A_32
#define _ARR3_1 MAX_MATCH_ORDER_COEFFS_3_A_33
#include "calc_match_max_order_template.F90"
#undef _THRESHOLD0
#undef _POINT0
#undef _ARR0_0
#undef _ARR0_1
#undef _THRESHOLD1
#undef _POINT1
#undef _ARR1_0
#undef _ARR1_1
#undef _THRESHOLD2
#undef _POINT2
#undef _ARR2_0
#undef _ARR2_1
#undef _THRESHOLD3
#undef _POINT3
#undef _ARR3_0
#undef _ARR3_1
#undef _FUNC

#define _FUNC CALC_MAX_MATCH_ORDER_A_128
#define _THRESHOLD0 THRESHOLD_0_A_128
#define _POINT0 BASE_SITE_0_A_128
#define _ARR0_0 MAX_MATCH_ORDER_COEFFS_0_A_128
#define _ARR0_1 MAX_MATCH_ORDER_COEFFS_0_A_129
#define _THRESHOLD1 THRESHOLD_1_A_128
#define _POINT1 BASE_SITE_1_A_128
#define _ARR1_0 MAX_MATCH_ORDER_COEFFS_1_A_128
#define _ARR1_1 MAX_MATCH_ORDER_COEFFS_1_A_129
#define _THRESHOLD2 THRESHOLD_2_A_128
#define _POINT2 BASE_SITE_2_A_128
#define _ARR2_0 MAX_MATCH_ORDER_COEFFS_2_A_128
#define _ARR2_1 MAX_MATCH_ORDER_COEFFS_2_A_129
#define _THRESHOLD3 THRESHOLD_3_A_128
#define _POINT3 BASE_SITE_3_A_128
#define _ARR3_0 MAX_MATCH_ORDER_COEFFS_3_A_128
#define _ARR3_1 MAX_MATCH_ORDER_COEFFS_3_A_129
#include "calc_match_max_order_template.F90"
#undef _THRESHOLD0
#undef _POINT0
#undef _ARR0_0
#undef _ARR0_1
#undef _THRESHOLD1
#undef _POINT1
#undef _ARR1_0
#undef _ARR1_1
#undef _THRESHOLD2
#undef _POINT2
#undef _ARR2_0
#undef _ARR2_1
#undef _THRESHOLD3
#undef _POINT3
#undef _ARR3_0
#undef _ARR3_1
#undef _FUNC

#define _FUNC CALC_MAX_MATCH_ORDER_B_8
#define _THRESHOLD0 THRESHOLD_0_B_8
#define _POINT0 BASE_SITE_0_B_8
#define _ARR0_0 MAX_MATCH_ORDER_COEFFS_0_B_8
#define _ARR0_1 MAX_MATCH_ORDER_COEFFS_0_B_9
#define _THRESHOLD1 THRESHOLD_1_B_8
#define _POINT1 BASE_SITE_1_B_8
#define _ARR1_0 MAX_MATCH_ORDER_COEFFS_1_B_8
#define _ARR1_1 MAX_MATCH_ORDER_COEFFS_1_B_9
#define _THRESHOLD2 THRESHOLD_2_B_8
#define _POINT2 BASE_SITE_2_B_8
#define _ARR2_0 MAX_MATCH_ORDER_COEFFS_2_B_8
#define _ARR2_1 MAX_MATCH_ORDER_COEFFS_2_B_9
#define _THRESHOLD3 THRESHOLD_3_B_8
#define _POINT3 BASE_SITE_3_B_8
#define _ARR3_0 MAX_MATCH_ORDER_COEFFS_3_B_8
#define _ARR3_1 MAX_MATCH_ORDER_COEFFS_3_B_9
#include "calc_match_max_order_template.F90"
#undef _THRESHOLD0
#undef _POINT0
#undef _ARR0_0
#undef _ARR0_1
#undef _THRESHOLD1
#undef _POINT1
#undef _ARR1_0
#undef _ARR1_1
#undef _THRESHOLD2
#undef _POINT2
#undef _ARR2_0
#undef _ARR2_1
#undef _THRESHOLD3
#undef _POINT3
#undef _ARR3_0
#undef _ARR3_1
#undef _FUNC

#define _FUNC CALC_MAX_MATCH_ORDER_B_32
#define _THRESHOLD0 THRESHOLD_0_B_32
#define _POINT0 BASE_SITE_0_B_32
#define _ARR0_0 MAX_MATCH_ORDER_COEFFS_0_B_32
#define _ARR0_1 MAX_MATCH_ORDER_COEFFS_0_B_33
#define _THRESHOLD1 THRESHOLD_1_B_32
#define _POINT1 BASE_SITE_1_B_32
#define _ARR1_0 MAX_MATCH_ORDER_COEFFS_1_B_32
#define _ARR1_1 MAX_MATCH_ORDER_COEFFS_1_B_33
#define _THRESHOLD2 THRESHOLD_2_B_32
#define _POINT2 BASE_SITE_2_B_32
#define _ARR2_0 MAX_MATCH_ORDER_COEFFS_2_B_32
#define _ARR2_1 MAX_MATCH_ORDER_COEFFS_2_B_33
#define _THRESHOLD3 THRESHOLD_3_B_32
#define _POINT3 BASE_SITE_3_B_32
#define _ARR3_0 MAX_MATCH_ORDER_COEFFS_3_B_32
#define _ARR3_1 MAX_MATCH_ORDER_COEFFS_3_B_33
#include "calc_match_max_order_template.F90"
#undef _THRESHOLD0
#undef _POINT0
#undef _ARR0_0
#undef _ARR0_1
#undef _THRESHOLD1
#undef _POINT1
#undef _ARR1_0
#undef _ARR1_1
#undef _THRESHOLD2
#undef _POINT2
#undef _ARR2_0
#undef _ARR2_1
#undef _THRESHOLD3
#undef _POINT3
#undef _ARR3_0
#undef _ARR3_1
#undef _FUNC

#define _FUNC CALC_MAX_MATCH_ORDER_B_128
#define _THRESHOLD0 THRESHOLD_0_B_128
#define _POINT0 BASE_SITE_0_B_128
#define _ARR0_0 MAX_MATCH_ORDER_COEFFS_0_B_128
#define _ARR0_1 MAX_MATCH_ORDER_COEFFS_0_B_129
#define _THRESHOLD1 THRESHOLD_1_B_128
#define _POINT1 BASE_SITE_1_B_128
#define _ARR1_0 MAX_MATCH_ORDER_COEFFS_1_B_128
#define _ARR1_1 MAX_MATCH_ORDER_COEFFS_1_B_129
#define _THRESHOLD2 THRESHOLD_2_B_128
#define _POINT2 BASE_SITE_2_B_128
#define _ARR2_0 MAX_MATCH_ORDER_COEFFS_2_B_128
#define _ARR2_1 MAX_MATCH_ORDER_COEFFS_2_B_129
#define _THRESHOLD3 THRESHOLD_3_B_128
#define _POINT3 BASE_SITE_3_B_128
#define _ARR3_0 MAX_MATCH_ORDER_COEFFS_3_B_128
#define _ARR3_1 MAX_MATCH_ORDER_COEFFS_3_B_129
#include "calc_match_max_order_template.F90"
#undef _THRESHOLD0
#undef _POINT0
#undef _ARR0_0
#undef _ARR0_1
#undef _THRESHOLD1
#undef _POINT1
#undef _ARR1_0
#undef _ARR1_1
#undef _THRESHOLD2
#undef _POINT2
#undef _ARR2_0
#undef _ARR2_1
#undef _THRESHOLD3
#undef _POINT3
#undef _ARR3_0
#undef _ARR3_1
#undef _FUNC

#define _FUNC CALC_MAX_MATCH_ORDER_C_8
#define _THRESHOLD0 THRESHOLD_0_C_8
#define _POINT0 BASE_SITE_0_C_8
#define _ARR0_0 MAX_MATCH_ORDER_COEFFS_0_C_8
#define _ARR0_1 MAX_MATCH_ORDER_COEFFS_0_C_9
#define _THRESHOLD1 THRESHOLD_1_C_8
#define _POINT1 BASE_SITE_1_C_8
#define _ARR1_0 MAX_MATCH_ORDER_COEFFS_1_C_8
#define _ARR1_1 MAX_MATCH_ORDER_COEFFS_1_C_9
#define _THRESHOLD2 THRESHOLD_2_C_8
#define _POINT2 BASE_SITE_2_C_8
#define _ARR2_0 MAX_MATCH_ORDER_COEFFS_2_C_8
#define _ARR2_1 MAX_MATCH_ORDER_COEFFS_2_C_9
#define _THRESHOLD3 THRESHOLD_3_C_8
#define _POINT3 BASE_SITE_3_C_8
#define _ARR3_0 MAX_MATCH_ORDER_COEFFS_3_C_8
#define _ARR3_1 MAX_MATCH_ORDER_COEFFS_3_C_9
#include "calc_match_max_order_template.F90"
#undef _THRESHOLD0
#undef _POINT0
#undef _ARR0_0
#undef _ARR0_1
#undef _THRESHOLD1
#undef _POINT1
#undef _ARR1_0
#undef _ARR1_1
#undef _THRESHOLD2
#undef _POINT2
#undef _ARR2_0
#undef _ARR2_1
#undef _THRESHOLD3
#undef _POINT3
#undef _ARR3_0
#undef _ARR3_1
#undef _FUNC

#define _FUNC CALC_MAX_MATCH_ORDER_C_32
#define _THRESHOLD0 THRESHOLD_0_C_32
#define _POINT0 BASE_SITE_0_C_32
#define _ARR0_0 MAX_MATCH_ORDER_COEFFS_0_C_32
#define _ARR0_1 MAX_MATCH_ORDER_COEFFS_0_C_33
#define _THRESHOLD1 THRESHOLD_1_C_32
#define _POINT1 BASE_SITE_1_C_32
#define _ARR1_0 MAX_MATCH_ORDER_COEFFS_1_C_32
#define _ARR1_1 MAX_MATCH_ORDER_COEFFS_1_C_33
#define _THRESHOLD2 THRESHOLD_2_C_32
#define _POINT2 BASE_SITE_2_C_32
#define _ARR2_0 MAX_MATCH_ORDER_COEFFS_2_C_32
#define _ARR2_1 MAX_MATCH_ORDER_COEFFS_2_C_33
#define _THRESHOLD3 THRESHOLD_3_C_32
#define _POINT3 BASE_SITE_3_C_32
#define _ARR3_0 MAX_MATCH_ORDER_COEFFS_3_C_32
#define _ARR3_1 MAX_MATCH_ORDER_COEFFS_3_C_33
#include "calc_match_max_order_template.F90"
#undef _THRESHOLD0
#undef _POINT0
#undef _ARR0_0
#undef _ARR0_1
#undef _THRESHOLD1
#undef _POINT1
#undef _ARR1_0
#undef _ARR1_1
#undef _THRESHOLD2
#undef _POINT2
#undef _ARR2_0
#undef _ARR2_1
#undef _THRESHOLD3
#undef _POINT3
#undef _ARR3_0
#undef _ARR3_1
#undef _FUNC

#define _FUNC CALC_MAX_MATCH_ORDER_C_128
#define _THRESHOLD0 THRESHOLD_0_C_128
#define _POINT0 BASE_SITE_0_C_128
#define _ARR0_0 MAX_MATCH_ORDER_COEFFS_0_C_128
#define _ARR0_1 MAX_MATCH_ORDER_COEFFS_0_C_129
#define _THRESHOLD1 THRESHOLD_1_C_128
#define _POINT1 BASE_SITE_1_C_128
#define _ARR1_0 MAX_MATCH_ORDER_COEFFS_1_C_128
#define _ARR1_1 MAX_MATCH_ORDER_COEFFS_1_C_129
#define _THRESHOLD2 THRESHOLD_2_C_128
#define _POINT2 BASE_SITE_2_C_128
#define _ARR2_0 MAX_MATCH_ORDER_COEFFS_2_C_128
#define _ARR2_1 MAX_MATCH_ORDER_COEFFS_2_C_129
#define _THRESHOLD3 THRESHOLD_3_C_128
#define _POINT3 BASE_SITE_3_C_128
#define _ARR3_0 MAX_MATCH_ORDER_COEFFS_3_C_128
#define _ARR3_1 MAX_MATCH_ORDER_COEFFS_3_C_129
#include "calc_match_max_order_template.F90"
#undef _THRESHOLD0
#undef _POINT0
#undef _ARR0_0
#undef _ARR0_1
#undef _THRESHOLD1
#undef _POINT1
#undef _ARR1_0
#undef _ARR1_1
#undef _THRESHOLD2
#undef _POINT2
#undef _ARR2_0
#undef _ARR2_1
#undef _THRESHOLD3
#undef _POINT3
#undef _ARR3_0
#undef _ARR3_1
#undef _FUNC

ENDMODULE
